function img_set = load_nifti_set(img_dir)

   img_name = '%s_foot_trial_%02d.nii';
   
   foot_side{1} = 'left';
   foot_side{2} = 'right';
   
   img_set.hdr.scan_name = img_dir;
   img_set.hdr.patient_name = 'unknown';
   img_set.hdr.scan_date = '01-01-1970';
   img_set.hdr.pixel_size_mm = [7.62 5.08];
   
   num_imgs = 1;
   for ii = 1:30,
       for jj = 1:2,
      
           img_loc = sprintf([img_dir, filesep, img_name], ...
                             foot_side{jj}, ii);
           if exist(img_loc, 'file'),
           
               nii = niftiread(img_loc);
               info = niftiinfo(img_loc);
               
               img_set.hdr.frame_dt_ms = info.raw.pixdim(4);
               
               img_set.imgs(num_imgs).foot_side = foot_side{jj};
               img_set.imgs(num_imgs).bounding_box = ...
                   [info.raw.dim(2:3), info.raw.dim(3:-1:2)];
               img_set.imgs(num_imgs).num_frames = info.raw.dim(4);
               img_set.imgs(num_imgs).img = nii;
               
               num_imgs = num_imgs+1;
           end
       end
   end
   