function label_img = my_bwlabeln(seg)
% function label_img = my_bwlabeln(seg)
%
% 
%
% Written by Brian Booth <brian.booth@uantwerpen.be>, May 2, 2017
%


   if ndims(seg) == 2,
       label_img = bwlabel(seg);
       return;
   end

   imSz = size(seg);
   
   label_img = zeros(imSz);
   n_objs = 1;
   
   shifts3 = [-1 -1 -1; -1 -1 0; -1 -1 1; -1 0 -1; -1 0 0; -1 0 1; ...
              -1 1 -1; -1 1 0; -1 1 1; 0 -1 -1; 0 -1 0; 0 -1 1; ...
              0 0 -1; 0 0 1; 0 1 -1; 0 1 0; 0 1 1; 1 -1 -1; 1 -1 0; ...
              1 -1 1; 1 0 -1; 1 0 0; 1 0 1; 1 1 -1; 1 1 0; 1 1 1];
   
   for ii = 1:numel(seg),

       if seg(ii) > 0,

           [xx, yy, zz] = ind2sub(imSz, ii);
           
           neighbours = shifts3;
           neighbours(:,1) = neighbours(:,1) + xx;
           neighbours(:,2) = neighbours(:,2) + yy;
           neighbours(:,3) = neighbours(:,3) + zz;
           neighbours = max(neighbours, 1);
           neighbours(:,1) = min(neighbours(:,1), imSz(1));
           neighbours(:,2) = min(neighbours(:,2), imSz(2));
           neighbours(:,3) = min(neighbours(:,3), imSz(3));
           
           idx = sub2ind(imSz, neighbours(:,1), neighbours(:,2), ...
                         neighbours(:,3));
           
           obj_labels = label_img(idx);
           obj_labels = obj_labels(obj_labels > 0);
           obj_labels = unique(obj_labels);
           
           
           if numel(obj_labels) == 1,
               label_img(ii) = obj_labels;
           elseif numel(obj_labels) == 0,
               label_img(ii) = n_objs;
               n_objs = n_objs + 1;
           else
               new_label = min(obj_labels);
               label_img(ii) = new_label;
               for jj = 1:numel(obj_labels),
                   label_img(label_img == obj_labels(jj)) = new_label;
               end
               label_img(label_img > new_label) = ...
                   label_img(label_img > new_label) - ...
                   (numel(obj_labels)-1);
               n_objs = n_objs - (numel(obj_labels)-1);
           end
           
       end
       
   end
   