function [xi, yi] = my_curve_intersect(x1, y1, x2, y2)
% function [xi, yi] = my_curve_intersect(x1, y1, x2, y2)
%
% Find the points where the line given by [x1, y1] intersects the
% curve given by [x2, y2].
%
% Written by Brian Booth <brian.booth@uantwerpen.be>, May 10, 2017
%

   m = (y1(2) - y1(1)) ./ (x1(2) - x1(1));
   b = y1(1) - m * x1(1);
   
   xx = 1:max(x1);
   yy = m*xx+b;
   
   % plot(xx, yy, 'b-');
   % hold on;
   % plot(x2, y2, 'r*');
   % hold off;
   % axis image;
   % drawnow;
   % pause;
   
   d = real(sqrt((y2 - (m * x2 + b)).^2));

   % plot(d);
   % drawnow;
   % pause;
   
   [pk_vals, idx] = findpeaks(-d);
   
   idx = idx(pk_vals > -1);
   
   xi = x2(idx)';
   yi = y2(idx)';
   