function maskIM = threshold_scan(img)
% function maskIM = threshold_scan(img)
%
% Threshold the given plantar pressure image to get a segmentation
% of the footstep.
%
% Arguments:
%      img - The 2D+time plantar pressure image
%     
% Returns:
%      maskIM - A 2D+time binary segmentation of the foot.
%
% Written by Brian Booth <brian.booth@uantwerpen.be>, July 12, 2016
%


    %img = img ./ max(img(:));
    t = 0.02 * max(img(:));
    maskIM = img > t;