function template_image = make_template(image_set)
% function template_image = make_template(image_set)
%
% Generate a template peak pressure image by averaging the given
% peak pressure images in terms foot size, foot shape, and the peak
% pressures themselves.
%
% Inputs:
%    -image_set: An Nx1 cell array containing the peak pressure
%                images from which the template will be made.
%
% Outputs:
%    - template_image: The population average image that will serve
%                      as a template for future modelling and
%                      analysis. 
%
% Written by Brian Booth <brian.booth@uantwerpen.be>
%

  if ~exist('tree_mean_unbias'),
      p = mfilename('fullpath');
      [dir,~,~] = fileparts(p);
      addpath([dir, filesep, 'helper_functions']);
  end

  [template_image, ~] = tree_mean_unbias(image_set);
  